Index: Singular/LIB/tropical.lib
===================================================================
--- Singular/LIB/tropical.lib	(revision fba86f89b3458187b40c5f0d5f6408412d98d295)
+++ Singular/LIB/tropical.lib	(revision 7d56875cf7720719f5b6acd193768a4d5b57848f)
@@ -1306,5 +1306,5 @@
     int rdnum=random(1000,9999);
     write(":w /tmp/tropicalcurve"+string(rdnum)+".tex",TEXBILD);
-    system("sh","cd /tmp; latex /tmp/tropicalcurve"+string(rdnum)+".tex; dvips /tmp/tropicalcurve"+string(rdnum)+".dvi -o; /bin/rm tropicalcurve"+string(rdnum)+".log;  /bin/rm tropicalcurve"+string(rdnum)+".aux;  /bin/rm tropicalcurve"+string(rdnum)+".ps?;  /bin/rm tropicalcurve"+string(rdnum)+".dvi; kghostview tropicalcurve"+string(rdnum)+".ps &");  
+    system("sh","cd /tmp; latex /tmp/tropicalcurve"+string(rdnum)+".tex; dvips /tmp/tropicalcurve"+string(rdnum)+".dvi -o; /bin/rm tropicalcurve"+string(rdnum)+".log;  /bin/rm tropicalcurve"+string(rdnum)+".aux;  /bin/rm tropicalcurve"+string(rdnum)+".ps?;  /bin/rm tropicalcurve"+string(rdnum)+".dvi; kghostview tropicalcurve"+string(rdnum)+".ps &");
   }
   else
@@ -1331,16 +1331,16 @@
 proc drawNewtonSubdivision (def f,list #)
 "USAGE:   drawTropicalCurve(f[,#]); f poly, # optional list
-ASSUME:   f is list of linear polynomials of the form ax+by+c with integers a, b and a rational number c 
+ASSUME:   f is list of linear polynomials of the form ax+by+c with integers a, b and a rational number c
           representing a tropical Laurent polynomial defining a tropical plane curve;
           alternatively f can be a polynomial in Q(t)[x,y] defining a tropical plane curve
-          via the valuation map; 
+          via the valuation map;
           the basering must have a global monomial ordering, two variables and up to one parameter!
 RETURN:   NONE
-NOTE:     - the procedure produces the files /tmp/newtonsubdivisionNUMBER.tex, 
-            and /tmp/newtonsubdivisionNUMBER.ps, where NUMBER is a random four digit integer; 
+NOTE:     - the procedure produces the files /tmp/newtonsubdivisionNUMBER.tex,
+            and /tmp/newtonsubdivisionNUMBER.ps, where NUMBER is a random four digit integer;
             moreover it desplays the tropical curve defined by f via kghostview;
             if you wish to remove all these files from /tmp, call the procedure cleanTmp
 @*          if # is empty, then the tropical curve is computed w.r.t. minimum, if #[1] is the
-            string 'max', then it is computed w.r.t. maximum 
+            string 'max', then it is computed w.r.t. maximum
 @*        - note that lattice points in the Newton subdivision which are black correspond to markings
             of the marked subdivision, while lattice points in grey are not marked
@@ -1357,5 +1357,5 @@
   { // write the tropical polynomial defined by f
     if (size(#)==0)
-    {      
+    {
       texf="\\min\\{";
     }
@@ -1366,5 +1366,5 @@
     for (j=1;j<=size(f);j++)
     {
-      texf=texf+texPolynomial(f[j]);    
+      texf=texf+texPolynomial(f[j]);
       if (j<size(f))
       {
@@ -1375,5 +1375,5 @@
         texf=texf+"\\}";
       }
-    }    
+    }
     list graph=tropicalCurve(f,#); // the graph of the tropical polynomial f
   }
@@ -1383,5 +1383,5 @@
    \\parindent0cm
    \\begin{center}
-      \\large\\bf The Newtonsubdivison of 
+      \\large\\bf The Newtonsubdivison of
       \\begin{displaymath}
           f="+texf+"
@@ -1391,5 +1391,5 @@
 
    \\begin{center}
-"+texDrawNewtonSubdivision(graph)+  
+"+texDrawNewtonSubdivision(graph)+
 "   \\end{center}
 
@@ -1397,5 +1397,5 @@
   int rdnum=random(1000,9999);
   write(":w /tmp/newtonsubdivision"+string(rdnum)+".tex",TEXBILD);
-  system("sh","cd /tmp; latex /tmp/newtonsubdivision"+string(rdnum)+".tex; dvips /tmp/newtonsubdivision"+string(rdnum)+".dvi -o; /bin/rm newtonsubdivision"+string(rdnum)+".log;  /bin/rm newtonsubdivision"+string(rdnum)+".aux;  /bin/rm newtonsubdivision"+string(rdnum)+".ps?;  /bin/rm newtonsubdivision"+string(rdnum)+".dvi; kghostview newtonsubdivision"+string(rdnum)+".ps &");  
+  system("sh","cd /tmp; latex /tmp/newtonsubdivision"+string(rdnum)+".tex; dvips /tmp/newtonsubdivision"+string(rdnum)+".dvi -o; /bin/rm newtonsubdivision"+string(rdnum)+".log;  /bin/rm newtonsubdivision"+string(rdnum)+".aux;  /bin/rm newtonsubdivision"+string(rdnum)+".ps?;  /bin/rm newtonsubdivision"+string(rdnum)+".dvi; kghostview newtonsubdivision"+string(rdnum)+".ps &");
 //  return(TEXBILD);
 }
@@ -1422,23 +1422,23 @@
 proc tropicalJInvariant (def f,list #)
 "USAGE:      tropicalJInvariant(f[,#]); f poly or list, # optional list
-ASSUME:      f is list of linear polynomials of the form ax+by+c with integers a, b and a rational number c 
+ASSUME:      f is list of linear polynomials of the form ax+by+c with integers a, b and a rational number c
              representing a tropical Laurent polynomial defining a tropical plane curve;
              alternatively f can be a polynomial in Q(t)[x,y] defining a tropical plane curve
-             via the valuation map; 
+             via the valuation map;
 @*           the basering must have a global monomial ordering, two variables and up to one parameter!
 RETURN:      number, if the graph underlying the tropical curve has precisely one loop then its weighted
                      lattice length is returned, otherwise the result will be -1
-NOTE:        - if the tropical curve is elliptic and its embedded graph has precisely one loop, 
+NOTE:        - if the tropical curve is elliptic and its embedded graph has precisely one loop,
                then the weigthed lattice length of the loop is its tropical j-invariant
-@*           - the procedure checks if the embedded graph of the tropical curve has genus one, 
-               but it does NOT check if the loop can be resolved, so that the curve is not 
-               a proper tropical elliptic curve 
+@*           - the procedure checks if the embedded graph of the tropical curve has genus one,
+               but it does NOT check if the loop can be resolved, so that the curve is not
+               a proper tropical elliptic curve
 @*           - if the embedded graph of a tropical elliptic curve has more than one loop, then
                all but one can be resolved, but this is not observed by this procedure, so it
                will not compute the j-invariant
 @*           - if # is empty, then the tropical curve is computed w.r.t. minimum, if #[1] is the
-               string 'max', then it is computed w.r.t. maximum 
+               string 'max', then it is computed w.r.t. maximum
 @*           - the tropicalJInvariant of a plane tropical cubic is the 'cycle length' of the
-               cubic as introduced in the paper: 
+               cubic as introduced in the paper:
                Erik Katz, Hannah Markwig, Thomas Markwig: The j-invariant of a cubic tropical plane curve.
 EXAMPLE:     example tropicalJInvariant;   shows an example"
@@ -1454,5 +1454,5 @@
     {
       if (typeof(f[1])=="list")
-      {        
+      {
         list graph=f;
       }
@@ -1466,5 +1466,5 @@
         {
           ERROR("This is no valid input.");
-        }        
+        }
       }
     }
@@ -1494,6 +1494,6 @@
   else
   {
-    intmat nullmat[2][1];  // used to set 
-    // 4) find a vertex which has only one bounded edge, if none exists zero is returned, 
+    intmat nullmat[2][1];  // used to set
+    // 4) find a vertex which has only one bounded edge, if none exists zero is returned,
     //    otherwise the number of the vertex in the list graph
     int nonloopvertex=findNonLoopVertex(graph);
@@ -1528,6 +1528,6 @@
     intvec loop,weights; // encodes the loop and the edges
     i=1;
-    //    start by finding some vertex which belongs to the loop 
-    while (loop==0) 
+    //    start by finding some vertex which belongs to the loop
+    while (loop==0)
     {
       if (ncols(graph[i][3])==1) // the graph[i][3] of a vertex in the loop has 2 columns, all others have 1
@@ -1537,6 +1537,6 @@
       else
       {
-        loop[1]=i; // a starting vertex is found 
-        loop[2]=graph[i][3][1,1]; // it is connected to the vertex with this number 
+        loop[1]=i; // a starting vertex is found
+        loop[2]=graph[i][3][1,1]; // it is connected to the vertex with this number
         weights[2]=graph[i][3][2,1]; // and the edge has this weight
       }
@@ -1549,5 +1549,5 @@
       // to which the active vertex j is connected; one is loop[k-1], i.e. the one which
       // precedes j in the loop; we have to choose the other one
-      if (graph[j][3][1,1]==loop[k-1]) 
+      if (graph[j][3][1,1]==loop[k-1])
       {
         loop[k+1]=graph[j][3][1,2];
@@ -1560,22 +1560,22 @@
       }
       j=loop[k+1]; // set loop[k+1] the new active vertex
-      k++; 
-    }    
+      k++;
+    }
     // 7) compute for each edge in the loop the lattice length
     poly xcomp,ycomp; // the x- and y-components of the vectors connecting two vertices of the loop
     number nenner;    // the product of the denominators of the x- and y-components
     number jinvariant;  // the j-invariant
-    int eins,zwei,ggt;  
+    int eins,zwei,ggt;
     for (i=1;i<=size(loop)-1;i++) // compute the lattice length for each edge
     {
-      xcomp=graph[loop[i]][1]-graph[loop[i+1]][1]; 
-      ycomp=graph[loop[i]][2]-graph[loop[i+1]][2]; 
+      xcomp=graph[loop[i]][1]-graph[loop[i+1]][1];
+      ycomp=graph[loop[i]][2]-graph[loop[i+1]][2];
       nenner=denominator(leadcoef(xcomp))*denominator(leadcoef(ycomp));
-      execute("eins="+string(numerator(leadcoef(nenner*xcomp)))+";"); 
-      execute("zwei="+string(numerator(leadcoef(nenner*ycomp)))+";"); 
+      execute("eins="+string(numerator(leadcoef(nenner*xcomp)))+";");
+      execute("zwei="+string(numerator(leadcoef(nenner*ycomp)))+";");
       ggt=gcd(eins,zwei); // the lattice length is the "gcd" of the x-component and the y-component
       jinvariant=jinvariant+ggt/(nenner*weights[i+1]); // divided by the weight of the edge
     }
-    return(jinvariant);   
+    return(jinvariant);
   }
 }
@@ -1591,10 +1591,10 @@
 // the curve can have arbitrary degree
    tropicalJInvariant(t*(x7+y7+1)+1/t*(x4+y4+x2+y2+x3y+xy3)+1/t7*x2y2);
-// the procedure does not realise, if the embedded graph of the tropical 
+// the procedure does not realise, if the embedded graph of the tropical
 //     curve has a loop that can be resolved
    tropicalJInvariant(1+x+y+xy+tx2y+txy2);
 // but it does realise, if the curve has no loop at all ...
    tropicalJInvariant(x+y+1);
-// or if the embedded graph has more than one loop - even if only one 
+// or if the embedded graph has more than one loop - even if only one
 //     cannot be resolved
    tropicalJInvariant(1+x+y+xy+tx2y+txy2+t3x5+t3y5+tx2y2+t2xy4+t2yx4);
@@ -1603,9 +1603,9 @@
 proc weierstrassForm (poly f,list #)
 "USAGE:      weierstrassFormOfACubic(wf[,#]); wf poly, # list
-ASSUME:      wf is a a polynomial whose Newton polygon has precisely one interior lattice
+ASSUME:      wf is a polynomial whose Newton polygon has precisely one interior lattice
              point, so that it defines an elliptic curve on the toric surface corresponding
              to the Newton polygon
 RETURN:      poly, the Weierstrass normal form of the polygon
-NOTE:        - the algorithm for the coefficients of the Weierstrass form is due to 
+NOTE:        - the algorithm for the coefficients of the Weierstrass form is due to
                Fernando Rodriguez Villegas, villegas@math.utexas.edu
 @*           - the characteristic of the base field should not be 2 or 3
@@ -1669,9 +1669,9 @@
 
 proc jInvariant (poly f,list #)
-"USAGE:      jInvariant(f[,#]); f poly, # list 
-ASSUME:      - f is a a polynomial whose Newton polygon has precisely one interior lattice
+"USAGE:      jInvariant(f[,#]); f poly, # list
+ASSUME:      - f is a polynomial whose Newton polygon has precisely one interior lattice
                point, so that it defines an elliptic curve on the toric surface corresponding
                to the Newton polygon
-@*           - it the optional argument # is present the base field should be Q(t) and 
+@*           - it the optional argument # is present the base field should be Q(t) and
                the optional argument should be one of the following strings:
 @*             'ord'   : then the return value is of type integer, namely the order of the j-invariant
@@ -1704,7 +1704,7 @@
    echo=2;
    ring r=(0,t),(x,y),dp;
-// jInvariant computes the j-invariant of a cubic 
+// jInvariant computes the j-invariant of a cubic
    jInvariant(x+y+x2y+y3+1/t*xy);
-// if the ground field has one parameter t, then we can instead 
+// if the ground field has one parameter t, then we can instead
 //    compute the order of the j-invariant
    jInvariant(x+y+x2y+y3+1/t*xy,"ord");
@@ -1714,5 +1714,5 @@
    poly h=x22y11+x19y10+x17y9+x16y9+x12y7+x9y6+x7y5+x2y3+x14y8;
 // its j-invariant is
-   jInvariant(h);  
+   jInvariant(h);
 }
 
@@ -1777,5 +1777,5 @@
   ring tRING=0,t,ls;
   list pointdenom=imap(BASERING,pointdenom);
-  list pointnum=imap(BASERING,pointnum);  
+  list pointnum=imap(BASERING,pointnum);
   intvec pointcoordinates;
   for (i=1;i<=size(pointdenom);i++)
@@ -1853,5 +1853,5 @@
    We consider the concic through the following five points:
    \\begin{displaymath}
-";  
+";
   string texf=texDrawTropical(graphf,list("",scalefactor));
   for (i=1;i<=size(points);i++)
@@ -1891,10 +1891,10 @@
 \\end{document}";
   setring BASERING;
-  // If # non-empty, compute the dual conic and the tangents through the dual points 
+  // If # non-empty, compute the dual conic and the tangents through the dual points
   // corresponding to the tangents of the given conic.
   if (size(#)>0)
   {
     list dualpoints;
-    for (i=1;i<=size(points);i++) 
+    for (i=1;i<=size(points);i++)
     {
       dualpoints[i]=list(leadcoef(tangents[i])/substitute(tangents[i],x,0,y,0),leadcoef(tangents[i]-lead(tangents[i]))/substitute(tangents[i],x,0,y,0));
@@ -1920,28 +1920,28 @@
 // conic[2] is the equation of the conic f passing through the five points
    conic[2];
-// conic[3] is a list containing the equations of the tangents 
+// conic[3] is a list containing the equations of the tangents
 //          through the five points
    conic[3];
 // conic[4] is an ideal representing the tropicalisation of the conic f
    conic[4];
-// conic[5] is a list containing the tropicalisation 
+// conic[5] is a list containing the tropicalisation
 //          of the five tangents in conic[3]
    conic[5];
-// conic[6] is a list containing the vertices of the tropical conic 
+// conic[6] is a list containing the vertices of the tropical conic
    conic[6];
 // conic[7] is a list containing the vertices of the five tangents
    conic[7];
-// conic[8] contains the latex code to draw the tropical conic and 
-//          its tropicalised tangents; it can written in a file, processed and 
-//          displayed via kghostview 
-   write(":w /tmp/conic.tex",conic[8]);   
-   system("sh","cd /tmp; latex /tmp/conic.tex; dvips /tmp/conic.dvi -o; 
+// conic[8] contains the latex code to draw the tropical conic and
+//          its tropicalised tangents; it can written in a file, processed and
+//          displayed via kghostview
+   write(":w /tmp/conic.tex",conic[8]);
+   system("sh","cd /tmp; latex /tmp/conic.tex; dvips /tmp/conic.dvi -o;
             kghostview conic.ps &");
-// with an optional argument the same information for the dual conic is computed 
+// with an optional argument the same information for the dual conic is computed
 //         and saved in conic[9]
    conic=conicWithTangents(points,1);
    conic[9][2]; // the equation of the dual conic
 }
- 
+
 ////////////////////////////////////////////////////////////////////////////////////
 /// Procedures concerned with tropicalisation
@@ -1952,7 +1952,7 @@
 ASSUME:      f is a polynomial in Q(t)[x_1,...,x_n]
 RETURN:      list, the linear forms of the tropicalisation of f
-NOTE:        if # is empty, then the valuation of t will be 1, 
-@*           if # is the string 'max' it will be -1; 
-@*           the latter supposes that we consider the maximum of the the computed 
+NOTE:        if # is empty, then the valuation of t will be 1,
+@*           if # is the string 'max' it will be -1;
+@*           the latter supposes that we consider the maximum of the computed
              linear forms, the former that we consider their minimum
 EXAMPLE:     example tropicalise;   shows an example"
@@ -1977,5 +1977,5 @@
     {
       tropicalf[i]=tropicalf[i]+exp[j]*var(j);
-    }    
+    }
     f=f-lead(f);
   }
@@ -2013,5 +2013,5 @@
 }
 
-proc tInitialForm (poly f, intvec w) 
+proc tInitialForm (poly f, intvec w)
 "USAGE:      tInitialForm(f,w); f a polynomial, w an integer vector
 ASSUME:      f is a polynomial in Q[t,x_1,...,x_n] and w=(w_0,w_1,...,w_n)
@@ -2026,6 +2026,6 @@
   // do the same for the remaining part of f and compare the results
   // keep only the smallest ones
-  int vglgewicht;  
-  f=f-lead(f); 
+  int vglgewicht;
+  f=f-lead(f);
   while (f!=0)
   {
@@ -2042,5 +2042,5 @@
         initialf=initialf+lead(f);
       }
-    }    
+    }
     f=f-lead(f);
   }
@@ -2058,7 +2058,7 @@
 }
 
-proc tInitialIdeal (ideal i,intvec w,list #) 
+proc tInitialIdeal (ideal i,intvec w,list #)
 "USAGE:      tInitialIdeal(i,w); i ideal, w intvec
-ASSUME:      i is an ideal in Q[t,x_1,...,x_n] and w=(w_0,...,w_n) 
+ASSUME:      i is an ideal in Q[t,x_1,...,x_n] and w=(w_0,...,w_n)
 RETURN:      ideal ini, the t-initial ideal of i with respect to w"
 {
@@ -2087,7 +2087,7 @@
   // ... and compute a standard basis with
   // respect to the homogenised ordering defined by w. Since the generators
-  // of i will be homogeneous it we can instead take the ordering wp 
-  // with the weightvector (0,w) replaced by (M,...,M)+(0,w) for some 
-  // large M, so that all entries are positive 
+  // of i will be homogeneous it we can instead take the ordering wp
+  // with the weightvector (0,w) replaced by (M,...,M)+(0,w) for some
+  // large M, so that all entries are positive
   int M=-minInIntvec(w)[1]+1; // find M such that w[j]+M is strictly positive for all j
   intvec whomog=M+1;
@@ -2097,6 +2097,6 @@
   }
   execute("ring WEIGHTRING=("+charstr(basering)+"),("+varstr(basering)+"),(wp("+string(whomog)+"));");
-  // map i to the new ring and compute a GB of i, then dehomogenise i, 
-  // so that we can be sure, that the 
+  // map i to the new ring and compute a GB of i, then dehomogenise i,
+  // so that we can be sure, that the
   // initial forms of the generators generate the initial ideal
   ideal i=subst(groebner(imap(HOMOGRING,i)),@s,1);
@@ -2343,5 +2343,5 @@
 proc texDrawBasic (list texdraw)
 "USAGE:      texDrawBasic(texdraw); list texdraw
-ASSUME:      texdraw is a list of strings representing texdraw commands (as produced by 
+ASSUME:      texdraw is a list of strings representing texdraw commands (as produced by
              texDrawTropical) which should be embedded into a texdraw environment
 RETURN:      string, a texdraw environment enclosing the input
@@ -2363,5 +2363,5 @@
     \\end{texdraw}";
   return(texdrawtp);
-}  
+}
 example
 {
@@ -2378,9 +2378,9 @@
 ASSUME:  graph is the output of tropicalCurve
 RETURN:  string, the texdraw code of the tropical plane curve encoded by graph
-NOTE:    - if the list # is non-empty, the first entry should be a string; if this string is 'max', 
+NOTE:    - if the list # is non-empty, the first entry should be a string; if this string is 'max',
            then the tropical curve is considered with respect to the maximum; otherwise the curve
-           is considered with respect to the minimum and the string can be used to 
+           is considered with respect to the minimum and the string can be used to
            insert further texdraw commands (e.g. to have a lighter image as when called
-           from inside conicWithTangents); 
+           from inside conicWithTangents);
 @*       - the procedure computes a scalefactor for the texdraw command which should
            help to display the curve in the right way; this may, however, be a bad idea
@@ -2392,5 +2392,5 @@
   int i,j;
   // deal first with the pathological case that the input polynomial was a monomial
-  // and does therefore not define a tropical curve, and check if the Newton polytope is 
+  // and does therefore not define a tropical curve, and check if the Newton polytope is
   // a line segment so that the curve defines a bunch of lines
   int bunchoflines;
@@ -2414,5 +2414,5 @@
   // go on with the case that a tropical curve is defined
   if (size(#)==0)
-  {    
+  {
      string texdrawtp="
 
@@ -2422,5 +2422,5 @@
   {
     if ((#[1]!="max") and (#[1]!=""))
-    {      
+    {
       string texdrawtp=#[1];
     }
@@ -2545,5 +2545,5 @@
 NOTE:        - the list # should contain as only entry a string; if this string is 'max', then
                the tropical curve is considered with respect to the maximum; otherwise the curve
-               is considered with respect to the minimum and the string can be used to 
+               is considered with respect to the minimum and the string can be used to
                insert further texdraw commands (e.g. to have a lighter image as when called
                from inside conicWithTangents); the list # is optional and may as well be empty
@@ -2554,5 +2554,5 @@
   int i,j,k,l;
   list boundary=graph[size(graph)][1];
-  list inneredges=graph[size(graph)][2];  
+  list inneredges=graph[size(graph)][2];
   intvec shiftvector=graph[size(graph)][3];
   string subdivision;
@@ -2566,5 +2566,5 @@
   poly scalefactor=minOfPolys(list(12/leadcoef(maxx),12/leadcoef(maxy)));
   if (scalefactor<1)
-  {    
+  {
     subdivision=subdivision+"
        \\relunitscale"+ decimal(scalefactor);
@@ -2574,9 +2574,9 @@
   {
     subdivision=subdivision+"
-        \\move ("+string(boundary[i][1])+" "+string(boundary[i][2])+")        
+        \\move ("+string(boundary[i][1])+" "+string(boundary[i][2])+")
         \\lvec ("+string(boundary[i+1][1])+" "+string(boundary[i+1][2])+")";
-  } 
+  }
   subdivision=subdivision+"
-        \\move ("+string(boundary[size(boundary)][1])+" "+string(boundary[size(boundary)][2])+")        
+        \\move ("+string(boundary[size(boundary)][1])+" "+string(boundary[size(boundary)][2])+")
         \\lvec ("+string(boundary[1][1])+" "+string(boundary[1][2])+")
 
@@ -2585,5 +2585,5 @@
   {
     subdivision=subdivision+"
-        \\move ("+string(inneredges[i][1][1])+" "+string(inneredges[i][1][2])+")        
+        \\move ("+string(inneredges[i][1][1])+" "+string(inneredges[i][1][2])+")
         \\lvec ("+string(inneredges[i][2][1])+" "+string(inneredges[i][2][2])+")";
   }
@@ -2605,5 +2605,5 @@
     }
   }
-  // deal with the pathological cases 
+  // deal with the pathological cases
   if (size(boundary)==1) // then the Newton polytope is a point
   {
@@ -2660,11 +2660,11 @@
   {
     subdivision=subdivision+"
-       \\move ("+string(markings[i][1])+" "+string(markings[i][2])+") 
+       \\move ("+string(markings[i][1])+" "+string(markings[i][2])+")
        \\fcir f:0 r:"+decimal(2/(8*scalefactor),size(string(int(scalefactor)))+1);
   }
   // enclose subdivision in the texdraw environment
-  string texsubdivision="     
+  string texsubdivision="
     \\begin{texdraw}
-       \\drawdim cm  \\relunitscale 1 
+       \\drawdim cm  \\relunitscale 1
        \\linewd 0.05"
     +subdivision+"
@@ -2680,5 +2680,5 @@
    poly f=x+y+x2y+xy2+1/t*xy;
    list graph=tropicalCurve(f);
-// compute the texdraw code of the Newton subdivision of the tropical curve 
+// compute the texdraw code of the Newton subdivision of the tropical curve
    texDrawNewtonSubdivision(graph);
 }
@@ -2707,5 +2707,5 @@
     markings[3*i-2]=triang[i][1];
     markings[3*i-1]=triang[i][2];
-    markings[3*i]=triang[i][3];    
+    markings[3*i]=triang[i][3];
   }
   // delete redundant pairs which occur more than once
@@ -2740,5 +2740,5 @@
   {
     latex=latex+"
-        \\move ("+string(polygon[markings[i]][1])+" "+string(polygon[markings[i]][2])+")        
+        \\move ("+string(polygon[markings[i]][1])+" "+string(polygon[markings[i]][2])+")
         \\fcir f:0 r:0.08";
   }
@@ -2747,5 +2747,5 @@
   {
     latex=latex+"
-        \\move ("+string(polygon[pairs[i][1]][1])+" "+string(polygon[pairs[i][1]][2])+")        
+        \\move ("+string(polygon[pairs[i][1]][1])+" "+string(polygon[pairs[i][1]][2])+")
         \\lvec ("+string(polygon[pairs[i][2]][1])+" "+string(polygon[pairs[i][2]][2])+")";
   }
@@ -2754,5 +2754,5 @@
   {
     latex=latex+"
-        \\move ("+string(polygon[i][1])+" "+string(polygon[i][2])+")        
+        \\move ("+string(polygon[i][1])+" "+string(polygon[i][2])+")
         \\fcir f:0.7 r:0.04";
   }
@@ -2763,9 +2763,9 @@
    "EXAMPLE:";
    echo=2;
-   // the lattice polygon spanned by the points (0,0), (3,0) and (0,3) 
+   // the lattice polygon spanned by the points (0,0), (3,0) and (0,3)
    // with all integer points as markings
    list polygon=intvec(1,1),intvec(3,0),intvec(2,0),intvec(1,0),intvec(0,0),
                 intvec(2,1),intvec(0,1),intvec(1,2),intvec(0,2),intvec(0,3);
-   // define a triangulation by connecting the only interior point 
+   // define a triangulation by connecting the only interior point
    //        with the vertices
    list triang=intvec(1,2,5),intvec(1,5,10),intvec(1,2,10);
@@ -2775,5 +2775,5 @@
 
 ////////////////////////////////////////////////////////////////////////////////////
-/// Auxilary Procedures 
+/// Auxilary Procedures
 ////////////////////////////////////////////////////////////////////////////////////
 
@@ -2829,9 +2829,9 @@
   // do the same for the remaining part of f and compare the results
   // keep only the smallest ones
-  int vglgewicht;  
-  f=f-lead(f);  
+  int vglgewicht;
+  f=f-lead(f);
   while (f!=0)
   {
-    leitkoef=simplifyToOrder(f);    
+    leitkoef=simplifyToOrder(f);
     vglgewicht=leitkoef[1]+scalarproduct(w,leadexp(f));
     if (vglgewicht<gewicht)
@@ -2848,5 +2848,5 @@
         initialf=initialf+koef*leadmonom(f);
       }
-    }    
+    }
     f=f-lead(f);
   }
@@ -2872,5 +2872,5 @@
   // compute first the t-order of the leading coefficient of f (leitkoef[1]) and
   // the rational constant corresponding to this order in leadkoef(f) (leitkoef[2])
-  list leitkoef=simplifyToOrder(f);  
+  list leitkoef=simplifyToOrder(f);
   execute("poly koef="+leitkoef[2]+";");
   // take in lead(f) only the term of lowest t-order and set t=1
@@ -2881,5 +2881,5 @@
   // keep only the largest ones
   int vglgewicht;
-  f=f-lead(f);  
+  f=f-lead(f);
   while (f!=0)
   {
@@ -2899,5 +2899,5 @@
         initialf=initialf+koef*leadmonom(f);
       }
-    }    
+    }
     f=f-lead(f);
   }
@@ -2916,5 +2916,5 @@
 proc solveTInitialFormPar (ideal i)
 "USAGE:      solveTInitialFormPar(i); i ideal
-ASSUME:      i is a zero-dimensional ideal in Q(t)[x_1,...,x_n] generated by the (1,w)-homogeneous 
+ASSUME:      i is a zero-dimensional ideal in Q(t)[x_1,...,x_n] generated by the (1,w)-homogeneous
              elements for some integer vector w - i.e. by the (1,w)-initialforms of polynomials
 RETURN:      none
@@ -2941,5 +2941,5 @@
 }
 
-proc detropicalise (poly p) 
+proc detropicalise (poly p)
 "USAGE:      detropicalise(f); f poly
 ASSUME:      f is a linear polynomial with an arbitrary constant term and
@@ -2953,5 +2953,5 @@
   {
     if (leadmonom(p)!=1)
-    { 
+    {
       dtp=dtp*leadmonom(p)^int(leadcoef(p));
     }
@@ -3057,5 +3057,5 @@
    poly f=t2x+1/t*y-1;
    tropicalSubst(f,2,x,x+t,y,tx+y+t2);
-   // The procedure can be used to study the effect of a transformation of 
+   // The procedure can be used to study the effect of a transformation of
    // the form x -> x+t^b, with b a rational number, on the tropicalisation and
    // the j-invariant of a cubic over the Puiseux series.
@@ -3063,6 +3063,6 @@
    // - the j-invariant, and hence its valuation, does not change under the transformation
    jInvariant(f,"ord");
-   // - b=3/2, then the cycle length of the tropical cubic equals -val(j-inv)   
-   list g32=tropicalSubst(f,2,x,x+t3,y,y);  
+   // - b=3/2, then the cycle length of the tropical cubic equals -val(j-inv)
+   list g32=tropicalSubst(f,2,x,x+t3,y,y);
    tropicalJInvariant(g32);
    // - b=1, then it is still true, but only just ...
@@ -3075,9 +3075,9 @@
 
 proc randomPoly (int d,int ug, int og, list #)
-"USAGE:      randomPoly(d,ug,og[,#]);   d, ug, og int, # list 
+"USAGE:      randomPoly(d,ug,og[,#]);   d, ug, og int, # list
 ASSUME:      the basering has a parameter t
 RETURN:      poly, a polynomial of degree d where the coefficients are of the form t^j with
                    j a random integer between ug and og
-NOTE:        if an optional argument # is given, then the coefficients are instead either of the 
+NOTE:        if an optional argument # is given, then the coefficients are instead either of the
              form t^j as above or they are zero, and this is chosen randomly
 EXAMPLE:     example randomPoly;   shows an example"
@@ -3095,9 +3095,9 @@
   {
     if (size(#)!=0)
-    {      
+    {
       k=random(0,1);
     }
     if (k==0)
-    {      
+    {
       j=random(ug,og);
       randomPolynomial=randomPolynomial+t^j*m[i];
@@ -3127,5 +3127,5 @@
 RETURN:  none"
 {
-  system("sh","cd /tmp; /bin/rm -f tropicalcurve*; /bin/rm -f tropicalnewtonsubdivision*");  
+  system("sh","cd /tmp; /bin/rm -f tropicalcurve*; /bin/rm -f tropicalnewtonsubdivision*");
 }
 
@@ -3182,7 +3182,7 @@
 static proc cutdown (ideal jideal,intvec wvec,int dimension,list #)
 "USAGE:      cutdown(i,w,d); i ideal, w intvec, d int, # list
-ASSUME:      i an ideal in Q[t,x_1,...,x_n], (w_1,...,w_n) is in the tropical variety of jideal 
+ASSUME:      i an ideal in Q[t,x_1,...,x_n], (w_1,...,w_n) is in the tropical variety of jideal
              and d=dim(i)>0, in Q(t)[x]; the optional parameter # can contain the string 'isPrime'
-             to indicate that the input ideal is prime and no minimal associated primes have 
+             to indicate that the input ideal is prime and no minimal associated primes have
              to be computed
 RETURN:      list, the first entry is a ring, namely the basering where some variables have been
@@ -3195,9 +3195,9 @@
                    wvec with the components corresponding to the eliminated variables removed
 NOTE:        needs the libraries random.lib and primdec.lib; is called from tropicalLifting"
-{ 
-  // IDEA: i is an ideal of dimension d; we want to cut it with d random linear 
+{
+  // IDEA: i is an ideal of dimension d; we want to cut it with d random linear
   //       forms in such a way that the resulting
   //       ideal is 0-dim and still contains w in the tropical variety
-  // NOTE: t is the last variable in the basering  
+  // NOTE: t is the last variable in the basering
   ideal pideal;  //this is the ideal we want to return
   ideal cutideal;
@@ -3219,5 +3219,5 @@
     variablen=variablen+var(j1); //read the set of variables (needed to make the quotring later)
     product=product*var(j1); //make product of all variables (needed for the initial-monomial-check later
-  }    
+  }
   execute("ring QUOTRING=("+charstr(basering)+",t),("+string(variablen)+"),dp;");
   setring BASERING;
@@ -3226,12 +3226,12 @@
   {
     setring QUOTRING;
-    ideal jideal=imap(BASERING,jideal); 
-    list primp=minAssGTZ(jideal); //compute the primary decomposition  
+    ideal jideal=imap(BASERING,jideal);
+    list primp=minAssGTZ(jideal); //compute the primary decomposition
     for (j1=1;j1<=size(primp);j1++)
-    {      
+    {
       for(j2=1;j2<=size(primp[j1]);j2++)
       {
         primp[j1][j2]=primp[j1][j2]/content(primp[j1][j2]);// clear all denominators
-      }       
+      }
     }
     setring BASERING;
